diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/rfbproto.c vnc_unixsrc/vncviewer/rfbproto.c
--- vnc_unixsrc.orig/vncviewer/rfbproto.c	2008-09-05 19:51:24.000000000 -0400
+++ vnc_unixsrc/vncviewer/rfbproto.c	2010-04-17 22:34:38.000000000 -0400
@@ -212,211 +459,654 @@
 Bool
 InitialiseRFBConnection(void)
 {
-  rfbProtocolVersionMsg pv;
-  int server_major, server_minor;
-  int viewer_major, viewer_minor;
-  rfbClientInitMsg ci;
-  int secType;
+	rfbProtocolVersionMsg pv;
+	rfbClientInitMsg ci;
+	int i, secType, anon_dh = 0, accept_uvnc = 0;
+	FILE *pd;
+	char *hsfile = NULL;
+	char *hsparam[128];
+	char *envsetsec = getenv("SSVNC_SET_SECURITY_TYPE");
+	char line[128];
+	double dt = 0.0;
 
-  /* if the connection is immediately closed, don't report anything, so
-       that pmw's monitor can make test connections */
+	/* if the connection is immediately closed, don't report anything, so
+	   that pmw's monitor can make test connections */
 
-  if (listenSpecified)
-    errorMessageOnReadFailure = False;
+	if (listenSpecified) {
+		errorMessageOnReadFailure = False;
+	}
 
-  if (!ReadFromRFBServer(pv, sz_rfbProtocolVersionMsg))
-    return False;
+	for (i=0; i < 128; i++) {
+		hsparam[i] = NULL;
+	}
 
-  errorMessageOnReadFailure = True;
+	skip_XtUpdateAll = 1;
+	ProcessXtEvents();
+	skip_XtUpdateAll = 0;
+
+	if (getenv("SSVNC_PREDIGESTED_HANDSHAKE")) {
+		double start = dnow();
+		hsfile = getenv("SSVNC_PREDIGESTED_HANDSHAKE");
+		while (dnow() < start + 10.0) {
+			int done = 0;
+			usleep(100 * 1000);
+			if ((pd = fopen(hsfile, "r")) != NULL) {
+				while (fgets(line, 128, pd) != NULL) {
+					if (strstr(line, "done") == line) {
+						done = 1;
+						usleep(100 * 1000);
+						break;
+					}
+				}
+				fclose(pd);
+			}
+			if (done) {
+				break;
+			}
+		}
+		if ((pd = fopen(hsfile, "r")) != NULL) {
+			i = 0;
+			while (fgets(line, 128, pd) != NULL) {
+				hsparam[i] = strdup(line);
+				fprintf(stderr, "%s", line);
+				if (i++ > 100) break; 
+			}
+			fclose(pd);
+		}
+		unlink(hsfile);
+	}
 
-  pv[sz_rfbProtocolVersionMsg] = 0;
+	if (getenv("SSVNC_SKIP_RFB_PROTOCOL_VERSION")) {
+		viewer_major = 3;
+		viewer_minor = 8;
+		goto end_of_proto_msg;
+	} else if (hsfile) {
+		int k = 0;
+		while (hsparam[k] != NULL) {
+			char *str = hsparam[k++];
+			if (strstr(str, "server=") == str) {
+				sprintf(pv, "%s", str + strlen("server="));
+				goto readed_pv;
+			}
+		}
+	}
 
-  if (sscanf(pv, rfbProtocolVersionFormat,
-	     &server_major, &server_minor) != 2) {
-    fprintf(stderr,"Not a valid VNC server\n");
-    return False;
-  }
+	dt = dnow();
+	if (!ReadFromRFBServer(pv, sz_rfbProtocolVersionMsg)) {
+		return False;
+	}
+	if (getenv("PRINT_DELAY1")) fprintf(stderr, "delay1: %.3f ms\n", (dnow() - dt) * 1000);
+	dt = 0.0;
 
-  viewer_major = rfbProtocolMajorVersion;
-  if (server_major == 3 && server_minor >= rfbProtocolMinorVersion) {
-    /* the server supports at least the standard protocol 3.7 */
-    viewer_minor = rfbProtocolMinorVersion;
-  } else {
-    /* any other server version, request the standard 3.3 */
-    viewer_minor = rfbProtocolFallbackMinorVersion;
-  }
+	readed_pv:
 
-  fprintf(stderr, "Connected to RFB server, using protocol version %d.%d\n",
-	  viewer_major, viewer_minor);
+	errorMessageOnReadFailure = True;
 
-  sprintf(pv, rfbProtocolVersionFormat, viewer_major, viewer_minor);
+	pv[sz_rfbProtocolVersionMsg] = 0;
 
-  if (!WriteExact(rfbsock, pv, sz_rfbProtocolVersionMsg))
-    return False;
+	if (strstr(pv, "ID:") == pv) {
+		;
+	} else if (sscanf(pv, rfbProtocolVersionFormat, &server_major, &server_minor) != 2) {
+		if (strstr(pv, "test") == pv) {
+			/* now some hacks for ultraVNC SC III (SSL) ... testA, etc */
+			int i;
+			char *se = NULL;
+
+			fprintf(stderr,"Trying UltraVNC Single Click III workaround: %s\n", pv);
+			for (i=0; i < 7 ; i++) {
+				pv[i] = pv[i+5];
+			}
+			if (!ReadFromRFBServer(pv+7, 5)) {
+				return False;
+			}
+
+			se = getenv("STUNNEL_EXTRA_OPTS");
+			if (se == NULL) {
+				se = getenv("STUNNEL_EXTRA_OPTS_USER");
+			}
+			if (se != NULL) {
+				if (strstr(se, "options")) {
+					if (strstr(se, "ALL") || strstr(se, "DONT_INSERT_EMPTY_FRAGMENTS")) {
+						;	/* good */
+					} else {
+						se = NULL;
+					}
+				} else {
+					se = NULL;
+				}
+			}
+			if (se == NULL) {
+				msgbuf[0] = '\0';
+				strcat(msgbuf, "\n");
+				strcat(msgbuf, "***************************************************************\n");
+				strcat(msgbuf, "To work around UltraVNC SC III SSL dropping after a few minutes\n");
+				strcat(msgbuf, "you may need to set STUNNEL_EXTRA_OPTS_USER='options = ALL'.\n");
+				strcat(msgbuf, "***************************************************************\n");
+				strcat(msgbuf, "\n");
+				wmsg(msgbuf, 0);
+			}
+			if (strstr(pv, "ID:") == pv) {
+				goto check_ID_string;
+			}
+			if (sscanf(pv, rfbProtocolVersionFormat, &server_major, &server_minor) == 2) {
+				goto ultra_vnc_nonsense;
+			}
+		}
+		sprintf(msgbuf, "Not a valid VNC server: '%s'\n", pv);
+		wmsg(msgbuf, 1);
+		return False;
+	}
 
-  /* Read or select the security type. */
-  if (viewer_minor == rfbProtocolMinorVersion) {
-    secType = SelectSecurityType();
-  } else {
-    secType = ReadSecurityType();
-  }
-  if (secType == rfbSecTypeInvalid)
-    return False;
+	check_ID_string:
+	if (strstr(pv, "ID:") == pv) {
+		char tmp[256];
+		fprintf(stderr, "UltraVNC Repeater string detected: %s\n", pv);
+		fprintf(stderr, "Pretending to be UltraVNC repeater: reading 250 bytes...\n\n");
+		if (!ReadFromRFBServer(tmp, 250 - 12)) {
+			return False;
+		}
+		if (!ReadFromRFBServer(pv, 12)) {
+			return False;
+		}
+		if (sscanf(pv, rfbProtocolVersionFormat, &server_major, &server_minor) != 2) {
+			sprintf(msgbuf,"Not a valid VNC server: '%s'\n", pv);
+			wmsg(msgbuf, 1);
+			return False;
+		}
+	}
 
-  switch (secType) {
-  case rfbSecTypeNone:
-    fprintf(stderr, "No authentication needed\n");
-    break;
-  case rfbSecTypeVncAuth:
-    if (!AuthenticateVNC())
-      return False;
-    break;
-  case rfbSecTypeTight:
-    tightVncProtocol = True;
-    InitCapabilities();
-    if (!SetupTunneling())
-      return False;
-    if (!PerformAuthenticationTight())
-      return False;
-    break;
-  default:                      /* should never happen */
-    fprintf(stderr, "Internal error: Invalid security type\n");
-    return False;
-  }
+	ultra_vnc_nonsense:
+	fprintf(stderr,"\nProto: %s\n", pv);
 
-  ci.shared = (appData.shareDesktop ? 1 : 0);
+	viewer_major = 3;
 
-  if (!WriteExact(rfbsock, (char *)&ci, sz_rfbClientInitMsg))
-    return False;
+	if (appData.rfbVersion != NULL && sscanf(appData.rfbVersion, "%d.%d", &viewer_major, &viewer_minor) == 2) {
+		fprintf(stderr,"Setting RFB version to %d.%d from -rfbversion.\n\n", viewer_major, viewer_minor);
 
-  if (!ReadFromRFBServer((char *)&si, sz_rfbServerInitMsg))
-    return False;
+	} else if (getenv("SSVNC_RFB_VERSION") != NULL && sscanf(getenv("SSVNC_RFB_VERSION"), "%d.%d", &viewer_major, &viewer_minor) == 2) {
+		fprintf(stderr,"Setting RFB version to %d.%d from SSVNC_RFB_VERSION.\n\n", viewer_major, viewer_minor);
+
+	} else if (server_major > 3) {
+		viewer_minor = 8;
+	} else if (server_major == 3 && (server_minor == 14 || server_minor == 16)) {
+		/* hack for UltraVNC Single Click. They misuse rfb proto version */
+		fprintf(stderr,"Setting RFB version to 3.3 for UltraVNC Single Click.\n\n");
+		viewer_minor = 3;
+
+	} else if (server_major == 3 && server_minor >= 8) {
+		/* the server supports at least the standard protocol 3.8 */
+		viewer_minor = 8;
+
+	} else if (server_major == 3 && server_minor == 7) {
+		/* the server supports at least the standard protocol 3.7 */
+		viewer_minor = 7;
+
+	} else {
+		/* any other server version, request the standard 3.3 */
+		viewer_minor = 3;
+	}
+	/* n.b. Apple Remote Desktop uses 003.889, but we should be OK with 3.8 */
 
-  si.framebufferWidth = Swap16IfLE(si.framebufferWidth);
-  si.framebufferHeight = Swap16IfLE(si.framebufferHeight);
-  si.format.redMax = Swap16IfLE(si.format.redMax);
-  si.format.greenMax = Swap16IfLE(si.format.greenMax);
-  si.format.blueMax = Swap16IfLE(si.format.blueMax);
-  si.nameLength = Swap32IfLE(si.nameLength);
-
-  /* FIXME: Check arguments to malloc() calls. */
-  desktopName = malloc(si.nameLength + 1);
-  if (!desktopName) {
-    fprintf(stderr, "Error allocating memory for desktop name, %lu bytes\n",
-            (unsigned long)si.nameLength);
-    return False;
-  }
+	if (appData.msLogon) {
+		if (server_minor == 4) {
+			fprintf(stderr,"Setting RFB version to 3.4 for UltraVNC MS Logon.\n\n");
+			viewer_minor = 4;
+		}
+	}
+	if (getenv("SSVNC_ACCEPT_POPUP_SC")) {
+		if (server_minor == -4 || server_minor == -6 || server_minor == 14 || server_minor == 16) {
+			/* 4 and 6 work too? */
+			viewer_minor = server_minor;
+			accept_uvnc = 1;
+			fprintf(stderr,"Reset RFB version to 3.%d for UltraVNC SSVNC_ACCEPT_POPUP_SC.\n\n", viewer_minor);
+		}
+	}
 
-  if (!ReadFromRFBServer(desktopName, si.nameLength)) return False;
+	fprintf(stderr, "Connected to RFB server, using protocol version %d.%d\n", viewer_major, viewer_minor);
 
-  desktopName[si.nameLength] = 0;
+	if (hsfile) {
+		int k = 0;
+		while (hsparam[k] != NULL) {
+			char *str = hsparam[k++];
+			if (strstr(str, "latency=") == str) {
+				latency = 1000. * atof(str + strlen("latency="));
+			}
+		}
+		k = 0;
+		while (hsparam[k] != NULL) {
+			char *str = hsparam[k++];
+			int v1, v2;
+			if (sscanf(str, "viewer=RFB %d.%d\n", &v1, &v2) == 2) {
+				viewer_major = v1;
+				viewer_minor = v2;
+				fprintf(stderr, "\nPre-Handshake set protocol version to: %d.%d  Latency: %.2f ms\n", viewer_major, viewer_minor, latency);
+				goto end_of_proto_msg;
+			}
+		}
+	}
+	sprintf(pv, rfbProtocolVersionFormat, viewer_major, viewer_minor);
 
-  fprintf(stderr,"Desktop name \"%s\"\n",desktopName);
+	if (!appData.appShare) {
+		usleep(100*1000);
+	}
+	dt = dnow();
+	if (!WriteExact(rfbsock, pv, sz_rfbProtocolVersionMsg)) {
+		return False;
+	}
 
-  fprintf(stderr,"VNC server default format:\n");
-  PrintPixelFormat(&si.format);
+	end_of_proto_msg:
 
-  if (tightVncProtocol) {
-    /* Read interaction capabilities (protocol 3.7t) */
-    if (!ReadInteractionCaps())
-      return False;
-  }
+	if (envsetsec) {
+		secType = atoi(getenv("SSVNC_SET_SECURITY_TYPE"));
+		goto sec_type;
+	}
+	if (hsfile) {
+		int k = 0;
+		while (hsparam[k] != NULL) {
+			char *str = hsparam[k++];
+			int st;
+			if (sscanf(str, "sectype=%d\n", &st) == 1) {
+				secType = st;
+				fprintf(stderr, "Pre-Handshake set Security-Type to: %d (%s)\n", st, pr_sec_type(st));
+				if (secType == rfbSecTypeVencrypt) {
+					goto sec_type;
+				} else if (secType == rfbSecTypeAnonTls) {
+					break;
+				}
+			}
+		}
+	}
 
-  return True;
+	if (accept_uvnc) {
+		unsigned int msg_sz = 0;
+		unsigned int nimmer = 0;
+		char msg[3000];
+		char *msg_buf, *sip = NULL, *sih = NULL;
+
+		if (!ReadFromRFBServer((char *) &msg_sz, 4)) {
+			return False;
+		}
+		dt_out_sc = dnow();
+		msg_sz = Swap32IfBE(msg_sz);
+		if (msg_sz > 1024) {
+			fprintf(stderr, "UVNC msg size too big: %d\n", msg_sz);
+			exit(1);
+		}
+		msg_buf = (char *)calloc(msg_sz + 100, 1);
+		if (!ReadFromRFBServer(msg_buf, msg_sz)) {
+			return False;
+		}
+
+		if (0) {
+			fprintf(stderr, "msg_buf: ");
+			write(2, msg_buf, msg_sz);
+			fprintf(stderr, "\n");
+		}
+
+		sip = get_peer_ip(rfbsock);
+		if (strlen(sip) > 100) sip = "0.0.0.0";
+		sih = ip2host(sip);
+		if (strlen(sih) > 300) sih = "unknown";
+
+		sprintf(msg, "\n(LISTEN) Reverse VNC connection from IP: %s\n                               Hostname: %s\n\n", sip, sih);
+		strcat(msg, "UltraVNC Server Message:\n");
+		strcat(msg, msg_buf);
+		free(msg_buf);
+		strcat(msg, "\n\n");
+		strcat(msg, "Accept or Reject VNC connection?");
+		if (CreateMsg(msg, 2)) {
+			nimmer = 1;
+			fprintf(stderr, "Accepting connection.\n\n");
+		} else {
+			nimmer = 0;
+			fprintf(stderr, "Refusing connection.\n\n");
+		}
+		if (!WriteExact(rfbsock, (char *) &nimmer, 4)) {
+			return False;
+		}
+	}
+
+	/* Read or select the security type. */
+	dt_out = 0.0;
+
+	skip_XtUpdateAll = 1;
+	if (viewer_minor >= 7 && !accept_uvnc) {
+		secType = SelectSecurityType();
+	} else {
+		secType = ReadSecurityType();
+	}
+	skip_XtUpdateAll = 0;
+
+	if (accept_uvnc) {
+		dt_out = dt_out_sc;
+	}
+
+	if (dt > 0.0 && dt_out > dt) {
+		latency = (dt_out - dt) * 1000;
+	}
+	
+	fprintf(stderr, "Security-Type: %d (%s)  Latency: %.2f ms\n", (int) secType, pr_sec_type(secType), latency);
+	if (secType == rfbSecTypeInvalid) {
+		return False;
+	}
+
+	sec_type:
+
+	if (hsfile) {
+		int subsectype = 0;
+		int k = 0;
+		while (hsparam[k] != NULL) {
+			char *str = hsparam[k++];
+			int st;
+			if (sscanf(str, "subtype=%d\n", &st) == 1) {
+				subsectype = st;
+				fprintf(stderr, "Pre-Handshake set Sub-Security-Type to: %d (%s)\n\n", st, pr_sec_subtype(st));
+				break;
+			}
+		}
+
+		if (!subsectype) {
+			;
+		} else if (secType == rfbSecTypeVencrypt) {
+			if (subsectype == rfbVencryptTlsNone) {
+				anon_dh = 1;
+				secType = rfbSecTypeNone;
+			} else if (subsectype == rfbVencryptTlsVnc) {
+				anon_dh = 1;
+				secType = rfbSecTypeVncAuth;
+			} else if (subsectype == rfbVencryptTlsPlain) {
+				anon_dh = 1;
+				secType = rfbSecTypeNone;
+			} else if (subsectype == rfbVencryptX509None) {
+				secType = rfbSecTypeNone;
+			} else if (subsectype == rfbVencryptX509Vnc) {
+				secType = rfbSecTypeVncAuth;
+			} else if (subsectype == rfbVencryptX509Plain) {
+				secType = rfbSecTypeNone;
+			}
+			if (subsectype == rfbVencryptTlsPlain || subsectype == rfbVencryptX509Plain) {
+				usleep(300*1000);
+			}
+			if (subsectype == rfbVencryptTlsNone || subsectype == rfbVencryptTlsVnc || subsectype == rfbVencryptTlsPlain) {
+				char tmp[1000], line[100];
+				tmp[0] = '\0';
+				strcat(tmp, "\n");
+				sprintf(line, "WARNING: Anonymous Diffie-Hellman TLS used (%s),\n", pr_sec_subtype(subsectype));
+				strcat(tmp, line);
+				strcat(tmp, "WARNING: there will be *NO* Authentication of the VNC Server.\n");
+				strcat(tmp, "WARNING: I.e. a Man-In-The-Middle attack is possible.\n");
+				strcat(tmp, "WARNING: Configure the server to use X509 certs and verify them.\n\n");
+				wmsg(tmp, 1);
+			}
+			if (subsectype == rfbVencryptTlsPlain || subsectype == rfbVencryptX509Plain) {
+				fprintf(stderr, "\nVeNCrypt Plain (username + passwd) selected.\n\n");
+				if (appData.unixPW != NULL) {
+					unixpw(appData.unixPW, 1);
+				} else if (getenv("SSVNC_UNIXPW")) {
+					unixpw(getenv("SSVNC_UNIXPW"), 1);
+				} else {
+					unixpw(".", 1);
+				}
+			}
+		}
+	}
+
+	switch (secType) {
+		case rfbSecTypeNone:
+			fprintf(stderr, "No VNC authentication needed\n");
+			if (viewer_minor >= 8) {
+				CARD32 authResult;
+
+				if (!ReadFromRFBServer((char *)&authResult, 4)) {
+					return False;
+				}
+
+				authResult = Swap32IfLE(authResult);
+
+				if (authResult == rfbVncAuthOK) {
+					fprintf(stderr, "VNC authentication succeeded (%d) for rfbSecTypeNone (RFB 3.8)\n", (int) authResult);
+				} else {
+					sprintf(msgbuf, "VNC authentication failed (%d) for rfbSecTypeNone (RFB 3.8)\n\n", (int) authResult);
+					wmsg(msgbuf, 1);
+					return False;
+				}
+			}
+			fprintf(stderr, "\n");
+			break;
+		case rfbSecTypeVncAuth:
+			if (!AuthenticateVNC()) {
+				return False;
+			}
+			break;
+		case rfbSecTypeTight:
+			tightVncProtocol = True;
+			InitCapabilities();
+			if (!SetupTunneling()) {
+				return False;
+			}
+			if (!PerformAuthenticationTight()) {
+				return False;
+			}
+			break;
+		case rfbUltraVncMsLogon:
+			if (!AuthUltraVncMsLogon()) {
+				return False;
+			}
+			break;
+		default:                      /* should never happen */
+			sprintf(msgbuf, "Internal error: Invalid security type: %d\n", secType);
+			wmsg(msgbuf, 1);
+			return False;
+	}
+
+	connect_time = dnow();
+
+	ci.shared = (appData.shareDesktop ? 1 : 0);
+
+	if (!WriteExact(rfbsock, (char *)&ci, sz_rfbClientInitMsg)) {
+		return False;
+	}
+
+	if (!ReadFromRFBServer((char *)&si, sz_rfbServerInitMsg)) {
+		return False;
+	}
+
+	si.framebufferWidth = Swap16IfLE(si.framebufferWidth);
+	si.framebufferHeight = Swap16IfLE(si.framebufferHeight);
+	si.format.redMax = Swap16IfLE(si.format.redMax);
+	si.format.greenMax = Swap16IfLE(si.format.greenMax);
+	si.format.blueMax = Swap16IfLE(si.format.blueMax);
+	si.nameLength = Swap32IfLE(si.nameLength);
+
+	if (appData.chatOnly) {
+		si.framebufferWidth = 32;
+		si.framebufferHeight = 32;
+	}
+
+	/* FIXME: Check arguments to malloc() calls. */
+	desktopName = malloc(si.nameLength + 1);
+	memset(desktopName, 0, si.nameLength + 1);
+	if (!desktopName) {
+		fprintf(stderr, "Error allocating memory for desktop name, %lu bytes\n",
+		    (unsigned long)si.nameLength);
+		return False;
+	}
+
+	if (!ReadFromRFBServer(desktopName, si.nameLength)) {
+		return False;
+	}
+
+	desktopName[si.nameLength] = 0;
+
+	if (appData.appShare) {
+		int x_hint, y_hint;
+		char *p, *q = NULL;
+		p = desktopName;
+		while (*p != '\0') {
+ 			char *t = strstr(p, " XY=");
+			if (t) q = t;
+			p++;
+		}
+		if (q) {
+			int ok = 1;
+			p = q + strlen(" XY=");
+			while (*p != '\0') {
+				if (!strpbrk(p, "0123456789,+-")) {
+					ok = 0;
+				}
+				p++;
+			}
+			if (ok && sscanf(q+1, "XY=%d,%d", &x_hint, &y_hint) == 2) {
+				fprintf(stderr,"Using x11vnc appshare position: %s\n\n", q);
+				*q = '\0';
+				appshare_x_hint = x_hint;
+				appshare_y_hint = y_hint;
+			}
+		}
+	}
+
+	fprintf(stderr,"Desktop name \"%s\"\n\n", desktopName);
+
+	fprintf(stderr,"VNC server default format:\n");
+	PrintPixelFormat(&si.format);
+
+	if (tightVncProtocol) {
+		/* Read interaction capabilities (protocol 3.7t) */
+		if (!ReadInteractionCaps()) {
+			return False;
+		}
+	}
+
+	return True;
 }
 
 
 /*
- * Read security type from the server (protocol version 3.3)
+ * Read security type from the server (protocol 3.3)
  */
 
 static int
 ReadSecurityType(void)
 {
-  CARD32 secType;
+	CARD32 secType;
 
-  /* Read the security type */
-  if (!ReadFromRFBServer((char *)&secType, sizeof(secType)))
-    return rfbSecTypeInvalid;
+	/* Read the security type */
+	if (!ReadFromRFBServer((char *)&secType, sizeof(secType))) {
+		return rfbSecTypeInvalid;
+	}
+	dt_out = dnow();
 
-  secType = Swap32IfLE(secType);
+	secType = Swap32IfLE(secType);
 
-  if (secType == rfbSecTypeInvalid) {
-    ReadConnFailedReason();
-    return rfbSecTypeInvalid;
-  }
+	if (secType == rfbSecTypeInvalid) {
+		ReadConnFailedReason();
+		return rfbSecTypeInvalid;
+	}
 
-  if (secType != rfbSecTypeNone && secType != rfbSecTypeVncAuth) {
-    fprintf(stderr, "Unknown security type from RFB server: %d\n",
-            (int)secType);
-    return rfbSecTypeInvalid;
-  }
+	if (secType == rfbSecTypeNone) {
+		;	/* OK */
+	} else if (secType == rfbSecTypeVncAuth) {
+		;	/* OK */
+	} else if (secType == rfbUltraVncMsLogon) {
+		;	/* OK */
+	} else {
+		sprintf(msgbuf, "Unknown security type from RFB server: %d\n", (int)secType);
+		wmsg(msgbuf, 1);
+		return rfbSecTypeInvalid;
+	}
 
-  return (int)secType;
+	return (int)secType;
 }
 
 
 /*
- * Select security type from the server's list (protocol version 3.7)
+ * Select security type from the server's list (protocol 3.7)
  */
 
 static int
 SelectSecurityType(void)
 {
-  CARD8 nSecTypes;
-  char *secTypeNames[] = {"None", "VncAuth"};
-  CARD8 knownSecTypes[] = {rfbSecTypeNone, rfbSecTypeVncAuth};
-  int nKnownSecTypes = sizeof(knownSecTypes);
-  CARD8 *secTypes;
-  CARD8 secType = rfbSecTypeInvalid;
-  int i, j;
-
-  /* Read the list of secutiry types. */
-  if (!ReadFromRFBServer((char *)&nSecTypes, sizeof(nSecTypes)))
-    return rfbSecTypeInvalid;
-
-  if (nSecTypes == 0) {
-    ReadConnFailedReason();
-    return rfbSecTypeInvalid;
-  }
+	CARD8 nSecTypes;
+	char *secTypeNames[] = {"None", "VncAuth"};
+	CARD8 knownSecTypes[] = {rfbSecTypeNone, rfbSecTypeVncAuth};
+	int nKnownSecTypes = sizeof(knownSecTypes);
+	CARD8 *secTypes;
+	CARD8 secType = rfbSecTypeInvalid;
+	int i, j;
+
+	if (secTypeNames) {}
+
+	/* Read the list of security types. */
+	if (!ReadFromRFBServer((char *)&nSecTypes, sizeof(nSecTypes))) {
+		return rfbSecTypeInvalid;
+	}
+	dt_out = dnow();
 
-  secTypes = malloc(nSecTypes);
-  if (!ReadFromRFBServer((char *)secTypes, nSecTypes))
-    return rfbSecTypeInvalid;
-
-  /* Find out if the server supports TightVNC protocol extensions */
-  for (j = 0; j < (int)nSecTypes; j++) {
-    if (secTypes[j] == rfbSecTypeTight) {
-      free(secTypes);
-      secType = rfbSecTypeTight;
-      if (!WriteExact(rfbsock, (char *)&secType, sizeof(secType)))
-        return rfbSecTypeInvalid;
-      fprintf(stderr, "Enabling TightVNC protocol extensions\n");
-      return rfbSecTypeTight;
-    }
-  }
+	if (nSecTypes == 0) {
+		ReadConnFailedReason();
+		return rfbSecTypeInvalid;
+	}
 
-  /* Find first supported security type */
-  for (j = 0; j < (int)nSecTypes; j++) {
-    for (i = 0; i < nKnownSecTypes; i++) {
-      if (secTypes[j] == knownSecTypes[i]) {
-        secType = secTypes[j];
-        if (!WriteExact(rfbsock, (char *)&secType, sizeof(secType))) {
-          free(secTypes);
-          return rfbSecTypeInvalid;
-        }
-        break;
-      }
-    }
-    if (secType != rfbSecTypeInvalid) break;
-  }
+	secTypes = malloc(nSecTypes);
+	if (!ReadFromRFBServer((char *)secTypes, nSecTypes)) {
+		return rfbSecTypeInvalid;
+	}
+
+	if (getenv("SSVNC_DEBUG_SEC_TYPES")) {
+		for (j = 0; j < (int)nSecTypes; j++) {
+			fprintf(stderr, "sec-type[%d] %d\n", j, (int) secTypes[j]);
+		}
+	}
+
+	/* Find out if the server supports TightVNC protocol extensions */
+	for (j = 0; j < (int)nSecTypes; j++) {
+		if (getenv("VNCVIEWER_NO_SEC_TYPE_TIGHT")) {
+			break;
+		}
+		if (getenv("SSVNC_NO_SEC_TYPE_TIGHT")) {
+			break;
+		}
+#ifdef TURBOVNC
+		break;
+#endif
+		if (secTypes[j] == rfbSecTypeTight) {
+			free(secTypes);
+			secType = rfbSecTypeTight;
+			if (!WriteExact(rfbsock, (char *)&secType, sizeof(secType))) {
+				return rfbSecTypeInvalid;
+			}
+			fprintf(stderr, "Enabling TightVNC protocol extensions\n");
+			return rfbSecTypeTight;
+		}
+	}
+
+	/* Find first supported security type */
+	for (j = 0; j < (int)nSecTypes; j++) {
+		for (i = 0; i < nKnownSecTypes; i++) {
+			if (secTypes[j] == knownSecTypes[i]) {
+				secType = secTypes[j];
+				if (!WriteExact(rfbsock, (char *)&secType, sizeof(secType))) {
+				  free(secTypes);
+				  return rfbSecTypeInvalid;
+				}
+				break;
+				}
+		}
+		if (secType != rfbSecTypeInvalid) {
+			break;
+		}
+	}
 
-  free(secTypes);
+	if (secType == rfbSecTypeInvalid) {
+		fprintf(stderr, "Server did not offer supported security type:\n");
+		for (j = 0; j < (int)nSecTypes; j++) {
+			fprintf(stderr, "  sectype[%d] %d\n", j, (int) secTypes[j]);
+		}
+	}
 
-  if (secType == rfbSecTypeInvalid)
-    fprintf(stderr, "Server did not offer supported security type\n");
+	free(secTypes);
 
-  return (int)secType;
+	return (int)secType;
 }
 
 
@@ -451,6 +1141,9 @@
   return True;
 }
 
+static char *restart_session_pw = NULL;
+static int restart_session_len = 0;
+
 
 /*
  * Negotiate authentication scheme (protocol version 3.7t)
